unit BWTBaseUnit;
{-------------------------------------------------------------------------------
Burrows Wheeler Transformation
Base Unit
------------------------------
reSource v2.6
Copyright (C) 1998-2001 Victor Kasenda / gruv
http://go.to/gruv
email: vickas@singnet.com.sg


Desc:
  The base unit for TBWTCompress and TBWTExpand
  contains common procedures used by both of them.
-------------------------------------------------------------------------------}

(**) interface (**)
uses StructsUnit;

type
  TBWTBase = class
  protected
    in_block ,out_block: PBlock;

    procedure SwapBlocks;
  public
  end;


(**) implementation (**)

{-------------------------------------------------------------------------------
  Swap Blocks
  in_block and out_block exchange pointer values
-------------------------------------------------------------------------------}
procedure TBWTBase.SwapBlocks;
var
  temp_block: PBlock;
begin
  temp_block := in_block;
  in_block := out_block;
  out_block := temp_block;
end;


end.
